import { useEffect } from 'react';

function useManualRouter(router, {
  basename = '',
  routerMode = 'hash',
  routerHashType = 'slash',
  hashType = 'slash',
  resolveRouteName,
  routes
} = {}) {
  if (!router.isRunning) {
    if (routes) router.use({
      routes
    });
    router.start({
      basename,
      mode: routerMode,
      hashType: routerHashType || hashType
    });
    resolveRouteName && router.resolveRouteName(resolveRouteName);
  }

  useEffect(() => () => {
    if (router.isRunning) router.stop();
  }, [router]);
  return [router];
}

export default useManualRouter;