"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.array.from.js");

require("core-js/modules/es6.array.slice.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createHashHistory = createHashHistoryNew;
exports.createBrowserHistory = createBrowserHistoryNew;
exports.createMemoryHistory = createMemoryHistoryNew;
exports.getPossibleRouterMode = getPossibleRouterMode;
exports.confirmInterceptors = confirmInterceptors;
Object.defineProperty(exports, "getBaseHref", {
  enumerable: true,
  get: function get() {
    return _history.getBaseHref;
  }
});
Object.defineProperty(exports, "History", {
  enumerable: true,
  get: function get() {
    return _history.History;
  }
});
Object.defineProperty(exports, "HistoryFix", {
  enumerable: true,
  get: function get() {
    return _types.HistoryFix;
  }
});
exports.HistoryType = void 0;

require("core-js/modules/es6.regexp.search.js");

require("core-js/modules/es6.array.find-index.js");

require("core-js/modules/es6.string.includes.js");

require("core-js/modules/es7.array.includes.js");

var _history = require("./history");

var _util = require("./util");

var _types = require("./types");

var _ = require(".");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var HistoryType;
exports.HistoryType = HistoryType;

(function (HistoryType) {
  HistoryType["hash"] = "hash";
  HistoryType["browser"] = "browser";
  HistoryType["memory"] = "memory";
})(HistoryType || (exports.HistoryType = HistoryType = {}));

var RAINBOW_ROUTER_KEY = '__RAINBOW_ROUTER_GLOBAL__';

if (!window[RAINBOW_ROUTER_KEY]) {
  (0, _util.innumerable)(window, RAINBOW_ROUTER_KEY, {
    historys: {}
  });
}

var RAINBOW_ROUTER_GLOBAL = window[RAINBOW_ROUTER_KEY];

function eachInterceptor(interceptors, location, callback, index, nexts) {
  var item = interceptors[index];
  if (!item) return callback(true);
  if ((0, _.isFunction)(item)) item = {
    interceptor: item,
    router: null
  };
  var cb = (0, _util.once)(function (ok) {
    if (!ok) return callback(ok);
    if ((0, _.isFunction)(ok)) nexts.push(ok);
    eachInterceptor(interceptors, location, callback, index + 1, nexts);
  });
  if (item.router && item.router.isRunning) item.interceptor(location, cb);else cb(true);
}

function confirmInterceptors(interceptors, location, callback) {
  if ((0, _util.isHistory)(interceptors)) interceptors = interceptors.interceptors;
  var nexts = [];
  interceptors = _toConsumableArray(interceptors);
  return eachInterceptor(interceptors, location, function (ok) {
    nexts.forEach(function (next) {
      return next(ok);
    });
    callback(ok);
  }, 0, nexts);
}

function createStackInfo(index, location) {
  return {
    pathname: location.pathname,
    search: location.search,
    index: index,
    timestamp: Date.now()
  };
}

function createHistory(options, fn, type) {
  var interceptors = [];
  var history = fn();
  history.isHistoryInstance = true;
  history.interceptors = interceptors;

  history.interceptorTransitionTo = function (interceptor, router) {
    var _this = this;

    var idx = this.interceptors.findIndex(function (v) {
      return v.interceptor === interceptor;
    });

    if (idx < 0) {
      if (router && router.basename) {
        var parentRouter = null;
        this.interceptors.forEach(function (v) {
          if (v.router && router.basename.includes(v.router.basename)) {
            if (!parentRouter || parentRouter.basename < v.router.basename) parentRouter = v.router;
          }
        });
        if (router._updateParent) router._updateParent(parentRouter);
      }

      this.interceptors.push({
        interceptor: interceptor,
        router: router
      });
    }

    return function () {
      var idx = _this.interceptors.findIndex(function (v) {
        return v.interceptor === interceptor;
      });

      if (~idx) {
        _this.interceptors.splice(idx, 1);

        if (router.parent && router._updateParent) router._updateParent(null);
      }
    };
  };

  var needSession = type !== HistoryType.memory;
  var SessionStacksKey = "_RAINBOW_ROUTER_".concat(type.toUpperCase(), "_STACKS_");
  history.stacks = needSession ? (0, _util.getSessionStorage)(SessionStacksKey, true) || [] : [];
  var lastStackInfo = history.stacks[history.stacks.length - 1];

  if (!lastStackInfo || lastStackInfo.index !== history.index) {
    history.stacks.push(createStackInfo(history.index, history.location));
    if (needSession) (0, _util.setSessionStorage)(SessionStacksKey, history.stacks);
  }

  (0, _util.innumerable)(history, '_unlisten', history.listen(function (state) {
    if (!state) return;
    var location = state.location,
        index = state.index;
    var lastStackInfo = history.stacks[history.stacks.length - 1];

    if (lastStackInfo && index > lastStackInfo.index) {
      history.stacks.push(createStackInfo(index, location));
    } else {
      var idx = history.stacks.findIndex(function (v) {
        return v.index === index;
      });

      if (~idx) {
        history.stacks.splice(idx, history.stacks.length, createStackInfo(index, location));
      }
    }

    if (needSession) (0, _util.setSessionStorage)(SessionStacksKey, history.stacks); // console.log('[createHistory][listen]', location, action, index);
  }));
  (0, _util.innumerable)(history, '_unblock', history.block(function (_ref) {
    var action = _ref.action,
        location = _ref.location,
        callback = _ref.callback;
    location = _objectSpread({}, location);
    confirmInterceptors(interceptors, location, callback);
  }));
  return history;
}

function createHashHistoryNew(options) {
  if (RAINBOW_ROUTER_GLOBAL.historys.hash) {
    return RAINBOW_ROUTER_GLOBAL.historys.hash;
  }

  return RAINBOW_ROUTER_GLOBAL.historys.hash = createHistory(options, function () {
    return (0, _history.createHashHistory)(options);
  }, HistoryType.hash);
}

function createBrowserHistoryNew(options) {
  if (RAINBOW_ROUTER_GLOBAL.historys.browser) {
    return RAINBOW_ROUTER_GLOBAL.historys.browser;
  }

  return RAINBOW_ROUTER_GLOBAL.historys.browser = createHistory(options, function () {
    return (0, _history.createBrowserHistory)(options);
  }, HistoryType.browser);
}

function createMemoryHistoryNew(options) {
  return createHistory(options, function () {
    return (0, _history.createMemoryHistory)(options);
  }, HistoryType.memory);
}

function getPossibleRouterMode() {
  if (RAINBOW_ROUTER_GLOBAL.historys.hash) return 'hash';
  if (RAINBOW_ROUTER_GLOBAL.historys.browser) return 'browser';
  return '';
} // export {
//   createHashHistory,
//   createBrowserHistory,
//   createMemoryHistory,
//   History,
//   HistoryFix,
//   LocationState
// };
//# sourceMappingURL=history-fix.js.map