"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.array.slice.js");

require("core-js/modules/es6.array.from.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRouter = useRouter;
exports.useRouteChanged = useRouteChanged;
exports.useRouteMetaChanged = useRouteMetaChanged;
exports.useRoute = useRoute;
exports.useRouteMeta = useRouteMeta;
exports.useRouteState = useRouteState;
exports.useRouterView = useRouterView;
exports.useMatchedRouteIndex = useMatchedRouteIndex;
exports.useMatchedRoute = useMatchedRoute;
exports.useRouteGuardsRef = useRouteGuardsRef;
exports.createRouteGuardsRef = createRouteGuardsRef;

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.string.includes.js");

require("core-js/modules/es7.array.includes.js");

var _react = require("react");

var _context = require("../context");

var _util = require("../util");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function useRouter(defaultRouter) {
  // eslint-disable-next-line react-hooks/rules-of-hooks
  return defaultRouter || (0, _react.useContext)(_context.RouterContext);
}

function useRoute(defaultRouter) {
  var router = useRouter(defaultRouter);
  return router ? router.currentRoute || router.initialRoute : null;
}

function useRouteMeta(metaKey, defaultRouter) {
  var router = useRouter(defaultRouter);
  var route = useMatchedRoute(router);
  var meta = route && route.meta;
  var keyIsArray = Array.isArray(metaKey);
  if (keyIsArray && !metaKey.length) throw new Error('metaKey is Empty!');

  var _useState = (0, _react.useState)(function () {
    return keyIsArray ? metaKey.reduce(function (p, key) {
      if (!meta) return p;
      p[key] = meta[key];
      return p;
    }, {}) : _defineProperty({}, metaKey, meta && meta[metaKey]);
  }),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      _setValue = _useState2[1];

  var setValue = (0, _react.useCallback)(function (newValue) {
    var setAll = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    if (!meta) return;

    if (!keyIsArray) {
      newValue = _defineProperty({}, metaKey, newValue);
    } else if (!setAll) {
      newValue = Object.keys(newValue).reduce(function (p, key) {
        if (metaKey.includes(key)) p[key] = newValue[key];
        return p;
      }, {});
    }

    var changed = route && router && router.updateRouteMeta(route.config, newValue);
    if (!changed) return;

    _setValue(_objectSpread(_objectSpread({}, value), newValue));
  }, [meta, keyIsArray, route, router, value, metaKey]);
  return keyIsArray ? [value, setValue] : [value[metaKey], setValue];
}

function useRouterView() {
  return (0, _react.useContext)(_context.RouterViewContext);
}

function useMatchedRouteIndex() {
  var view = useRouterView();
  return view ? view.state._routerDepth : 0;
}

function useMatchedRoute(defaultRouter) {
  var route = useRoute(defaultRouter);
  var routeIndex = useMatchedRouteIndex();
  return route && route.matched[routeIndex] || null;
}

function useRouteState(defaultRouter) {
  var router = useRouter(defaultRouter);
  var route = useMatchedRoute(router || defaultRouter);
  var routeUrl = route && route.url;
  var setRouteState = (0, _react.useCallback)(function (newState) {
    return router && router.replaceState(newState, route || undefined);
  }, // eslint-disable-next-line react-hooks/exhaustive-deps
  [router, routeUrl]);
  return [route ? route.state : {}, setRouteState];
}

function useRouteChanged(router, onChange) {
  return (0, _react.useEffect)(function () {
    var unplugin = onChange && router.plugin(onChange);
    return function () {
      return unplugin && unplugin();
    };
  }, [router, onChange]);
}

function useRouteMetaChanged(router, onChange) {
  var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  return (0, _react.useEffect)(function () {
    var unplugin = onChange && router.plugin({
      onRouteMetaChange: function onRouteMetaChange(newVal, oldVal, route, router) {
        if (deps.length && !deps.some(function (v) {
          if ((0, _util.isPlainObject)(v)) return v === route.meta;
          return v in oldVal;
        })) return;
        return onChange(newVal, oldVal, route, router);
      }
    });
    return function () {
      return unplugin && unplugin();
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [router, onChange].concat(_toConsumableArray(deps)));
}

function createRouteGuardsRef(ref) {
  if (ref && !ref.__routeGuardInfoHooks) (0, _util.innumerable)(ref, '__routeGuardInfoHooks', true);
  return ref;
}

function useRouteGuardsRef(ref, guards) {
  var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  if (!(0, _util.isFunction)(guards)) deps.concat(guards);
  return (0, _react.useImperativeHandle)(ref, function () {
    var ret;
    if ((0, _util.isFunction)(guards)) ret = guards.apply(void 0, arguments);else ret = guards;
    return createRouteGuardsRef(ret);
  }, // eslint-disable-next-line react-hooks/exhaustive-deps
  deps);
}
//# sourceMappingURL=base.js.map