"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

function useManualRouter(router) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$basename = _ref.basename,
      basename = _ref$basename === void 0 ? '' : _ref$basename,
      _ref$routerMode = _ref.routerMode,
      routerMode = _ref$routerMode === void 0 ? 'hash' : _ref$routerMode,
      _ref$routerHashType = _ref.routerHashType,
      routerHashType = _ref$routerHashType === void 0 ? 'slash' : _ref$routerHashType,
      _ref$hashType = _ref.hashType,
      hashType = _ref$hashType === void 0 ? 'slash' : _ref$hashType,
      resolveRouteName = _ref.resolveRouteName,
      routes = _ref.routes;

  if (!router.isRunning) {
    if (routes) router.use({
      routes: routes
    });
    router.start({
      basename: basename,
      mode: routerMode,
      hashType: routerHashType || hashType
    });
    resolveRouteName && router.resolveRouteName(resolveRouteName);
  }

  (0, _react.useEffect)(function () {
    return function () {
      if (router.isRunning) router.stop();
    };
  }, [router]);
  return [router];
}

var _default = useManualRouter;
exports.default = _default;
//# sourceMappingURL=use-manual-router.js.map