"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.array.from.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime.js");

require("core-js/modules/es6.string.ends-with.js");

require("core-js/modules/es6.string.includes.js");

require("core-js/modules/es7.array.includes.js");

require("core-js/modules/es6.object.assign.js");

require("core-js/modules/es6.regexp.replace.js");

require("core-js/modules/es6.array.find.js");

require("core-js/modules/es6.array.find-index.js");

require("core-js/modules/es6.regexp.search.js");

require("core-js/modules/es6.regexp.match.js");

require("core-js/modules/es6.string.starts-with.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.array.map.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.promise.js");

require("core-js/modules/es7.object.values.js");

require("core-js/modules/es6.array.slice.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

var _historyFix = require("./history-fix");

var _config = _interopRequireDefault(require("./config"));

var _util = require("./util");

var _routeLazy = require("./route-lazy");

var _routeGuard = require("./route-guard");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFAULT_STATE_NAME = '[root]';
var HISTORY_METHS = ['push', 'replace', 'redirect', 'go', 'back', 'forward', 'block'];
var idSeed = 1;

var ReactViewRouter = /*#__PURE__*/function () {
  function ReactViewRouter() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$name = _ref.name,
        name = _ref$name === void 0 ? '' : _ref$name,
        _ref$mode = _ref.mode,
        mode = _ref$mode === void 0 ? 'hash' : _ref$mode,
        _ref$basename = _ref.basename,
        basename = _ref$basename === void 0 ? '' : _ref$basename,
        options = _objectWithoutProperties(_ref, ["name", "mode", "basename"]);

    _classCallCheck(this, ReactViewRouter);

    _defineProperty(this, "isReactViewRouterInstance", true);

    _defineProperty(this, "parent", null);

    _defineProperty(this, "children", []);

    _defineProperty(this, "options", void 0);

    _defineProperty(this, "mode", void 0);

    _defineProperty(this, "basename", void 0);

    _defineProperty(this, "basenameNoSlash", void 0);

    _defineProperty(this, "name", void 0);

    _defineProperty(this, "routeNameMap", {});

    _defineProperty(this, "routes", []);

    _defineProperty(this, "stacks", []);

    _defineProperty(this, "plugins", []);

    _defineProperty(this, "beforeEachGuards", []);

    _defineProperty(this, "beforeResolveGuards", []);

    _defineProperty(this, "afterEachGuards", []);

    _defineProperty(this, "resolveNameFns", []);

    _defineProperty(this, "prevRoute", null);

    _defineProperty(this, "currentRoute", null);

    _defineProperty(this, "pendingRoute", null);

    _defineProperty(this, "initialRoute", {});

    _defineProperty(this, "viewRoot", null);

    _defineProperty(this, "errorCallback", null);

    _defineProperty(this, "apps", []);

    _defineProperty(this, "Apps", []);

    _defineProperty(this, "isRunning", false);

    _defineProperty(this, "rememberInitialRoute", false);

    _defineProperty(this, "getHostRouterView", void 0);

    _defineProperty(this, "nextTick", void 0);

    _defineProperty(this, "_history", null);

    _defineProperty(this, "_unlisten", void 0);

    _defineProperty(this, "_uninterceptor", void 0);

    _defineProperty(this, "id", void 0);

    _defineProperty(this, "_nexting", null);

    _defineProperty(this, "vuelike", void 0);

    _defineProperty(this, "_interceptorCounter", 0);

    this.name = name || '';
    this.id = idSeed++;
    this.options = options;
    this.mode = mode;
    this.basename = basename;
    this.basenameNoSlash = basename ? basename.endsWith('/') ? basename.substr(0, basename.length - 1) : basename : basename;
    this.getHostRouterView = _util.getHostRouterView;
    this.nextTick = _util.nextTick.bind(this);
    this.use(options);
    if (!options.manual) this.start(undefined, true);
  }

  _createClass(ReactViewRouter, [{
    key: "_updateParent",
    value: function _updateParent(parent) {
      if (parent === this) parent = null;
      if (this.parent === parent) return;

      if (parent) {
        if (parent.children && !parent.children.includes(this)) parent.children.push(this);
      } else if (this.parent && this.parent.children) {
        var idx = this.parent.children.indexOf(this);
        if (~idx) this.parent.children.splice(idx, 1);
      }

      this.parent = parent;
    }
  }, {
    key: "_clear",
    value: function _clear() {
      var isInit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.initialRoute = {
        location: {}
      };
      this.prevRoute = null;
      this.currentRoute = null;
      this.pendingRoute = null;
      this._history = null;
      this.isRunning = false;
      this._interceptorCounter = 0;
    }
  }, {
    key: "history",
    get: function get() {
      var _this = this;

      if (this._history) return this._history;

      switch (this.mode) {
        case 'browser':
          this._history = (0, _historyFix.createBrowserHistory)(this.options);
          break;

        case 'memory':
          this._history = (0, _historyFix.createMemoryHistory)(this.options);
          break;

        default:
          this._history = (0, _historyFix.createHashHistory)(this.options);
      }

      HISTORY_METHS.forEach(function (key) {
        return _this[key] && (_this[key] = _this[key].bind(_this));
      });
      this._history && (this._history.destroy = function () {
        return _this._history = null;
      });
      return this._history;
    }
  }, {
    key: "pluginName",
    get: function get() {
      return this.name;
    }
  }, {
    key: "top",
    get: function get() {
      return this.parent ? this.parent.top : this;
    }
  }, {
    key: "isBrowserMode",
    get: function get() {
      return this.mode === 'browser';
    }
  }, {
    key: "isHashMode",
    get: function get() {
      return this.mode === 'hash';
    }
  }, {
    key: "isMemoryMode",
    get: function get() {
      return this.mode === 'memory';
    }
  }, {
    key: "start",
    value: function start() {
      var _this2 = this;

      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          mode = _ref2.mode,
          basename = _ref2.basename,
          options = _objectWithoutProperties(_ref2, ["mode", "basename"]);

      var isInit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      this.stop(isInit);
      Object.assign(this.options, options);
      if (mode !== undefined) this.mode = mode;
      if (basename !== undefined) this.basename = this.isMemoryMode ? '' : basename.replace(/\/{2,}/g, '/');
      if (this.basename && !/\/$/.test(this.basename)) this.basename += '/';
      this.basenameNoSlash = this.basename ? this.basename.substr(0, this.basename.length - 1) : this.basename;
      this._unlisten = this.history.listen(function (_ref3) {
        var location = _ref3.location;

        _this2.updateRoute(_objectSpread({}, location));
      });
      this._uninterceptor = this.history.interceptorTransitionTo(this._handleRouteInterceptor.bind(this), this);

      this._refreshInitialRoute();

      this.isRunning = true;
    }
  }, {
    key: "stop",
    value: function stop() {
      var isInit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (this._unlisten) {
        this._unlisten();

        this._unlisten = undefined;
      }

      if (this._uninterceptor) {
        this._uninterceptor();

        this._uninterceptor = undefined;
      }

      if (this._history && this._history.destroy) {
        this._history.destroy();
      }

      this._clear(isInit = false);
    }
  }, {
    key: "use",
    value: function use(_ref4) {
      var routes = _ref4.routes,
          inheritProps = _ref4.inheritProps,
          rememberInitialRoute = _ref4.rememberInitialRoute,
          install = _ref4.install,
          restOptions = _objectWithoutProperties(_ref4, ["routes", "inheritProps", "rememberInitialRoute", "install"]);

      if (rememberInitialRoute !== undefined) this.rememberInitialRoute = rememberInitialRoute;

      if (routes) {
        this.routes = routes ? (0, _util.normalizeRoutes)(routes) : [];

        this._walkRoutes(this.routes);

        if (this._history && this.initialRoute) this._refreshInitialRoute();
      }

      if (inheritProps !== undefined) _config.default.inheritProps = inheritProps;
      Object.assign(_config.default, restOptions);
      if (install) this.install = install.bind(this);
    }
  }, {
    key: "plugin",
    value: function plugin(_plugin) {
      var _this3 = this;

      if ((0, _util.isFunction)(_plugin)) {
        _plugin = this.plugins.find(function (p) {
          return p.onRouteChange === _plugin;
        }) || {
          onRouteChange: _plugin
        };
      } else if (~this.plugins.indexOf(_plugin)) return;

      var idx = this.plugins.findIndex(function (p) {
        if (_plugin.name) return p.name === _plugin.name;
        return p === _plugin;
      });

      if (~idx) {
        var _this$plugins$splice = this.plugins.splice(idx, 1, _plugin),
            _this$plugins$splice2 = _slicedToArray(_this$plugins$splice, 1),
            old = _this$plugins$splice2[0];

        if (old && old.uninstall) old.uninstall(this);
      } else this.plugins.push(_plugin);

      if (_plugin.install) _plugin.install(this);
      return function () {
        var idx = _this3.plugins.indexOf(_plugin);

        if (~idx) {
          _this3.plugins.splice(idx, 1);

          if (_plugin.uninstall) _plugin.uninstall(_this3);
        }
      };
    }
  }, {
    key: "_walkRoutes",
    value: function _walkRoutes(routes) {
      var _this4 = this;

      (0, _util.walkRoutes)(routes, function (route, routeIndex, rs) {
        _this4._callEvent('onWalkRoute', route, routeIndex, rs);

        if (route.name) {
          var name = (0, _util.camelize)(route.name);

          if (_this4.routeNameMap[name]) {
            (0, _util.warn)("[react-view-router] route name '".concat(route.name, "'(path is [").concat(route.path, "]) is duplicate with [").concat(_this4.routeNameMap[name], "]"));
          }

          _this4.routeNameMap[name] = route.path;
        }
      });
    }
  }, {
    key: "_refreshInitialRoute",
    value: function _refreshInitialRoute() {
      var historyLocation = _objectSpread({}, this.history.location);

      if (window && window.location && window.location.search !== historyLocation.search) {
        var search = window.location.search;

        if (window.location.hash) {
          var _ref5 = window.location.hash.match(/#[a-z0-9-_/]+\?(.+)/i) || [],
              _ref6 = _slicedToArray(_ref5, 2),
              hashSearch = _ref6[1];

          if (hashSearch) search = search + (search ? '&' : '?') + hashSearch;
        }

        historyLocation.search = search;
      }

      this.updateRoute(historyLocation);

      if (this.rememberInitialRoute) {
        var stack;

        if (this.basename) {
          var stacks = this.history.stacks.concat(historyLocation).reverse();
          var basename = this.basenameNoSlash;
          stack = stacks.find(function (stack, i) {
            return stack.pathname.startsWith(basename) && (i === stacks.length - 1 || !stacks[i + 1].pathname.startsWith(basename));
          });
        } else if (!this.isMemoryMode && this.history.stacks.length) {
          stack = this.history.stacks[0];
        }

        if (stack) {
          historyLocation = (0, _util.normalizeLocation)({
            pathname: stack.pathname,
            search: stack.search
          });

          if (window.location.search) {
            var query = this.parseQuery(window.location.search);

            if (this.isHashMode) {
              Object.assign(historyLocation.query, query);
            } else if (this.isBrowserMode) {
              Object.keys(historyLocation.query).forEach(function (key) {
                if (query[key] !== undefined) historyLocation.query[key] = query[key];
              });
            }
          }
        }
      }

      this.initialRoute = this.createRoute(this._transformLocation(historyLocation)); // innumerable(this.initialRoute, 'location', location);
    }
  }, {
    key: "_callEvent",
    value: function _callEvent(event) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var plugin = null;

      try {
        var ret;
        this.plugins.forEach(function (p) {
          var _p$event;

          plugin = p;

          var newRet = p[event] && (_p$event = p[event]).call.apply(_p$event, [p].concat(args, [ret]));

          if (newRet !== undefined) ret = newRet;
        });
        return ret;
      } catch (ex) {
        if (plugin && plugin.name && ex && ex.message) {
          ex.message = "[".concat(plugin.name, ":").concat(event, "]").concat(ex.message);
        }

        throw ex;
      }
    }
  }, {
    key: "_isVuelikeComponent",
    value: function _isVuelikeComponent(comp) {
      return comp && this.vuelike && ( // eslint-disable-next-line no-proto
      comp.__proto__ && comp.isVuelikeComponentInstance || comp.__vuelike || comp.__vuelikeComponentClass);
    }
  }, {
    key: "_getComponentGurads",
    value: function _getComponentGurads(mr, guardName) {
      var _this5 = this;

      var bindInstance = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var ret = [];
      var componentInstances = mr.componentInstances; // route config

      var routeGuardName = guardName.replace('Route', '');
      var r = mr.config;
      var guards = r[routeGuardName];
      if (guards) ret.push(guards);

      var toResovle = function toResovle(c, key) {
        var ret = [];

        if (c) {
          var cc = c.__component ? (0, _routeGuard.getGuardsComponent)(c, true) : c;
          var cg = c.__guards && c.__guards[guardName];
          if (cg) ret.push(cg);
          var ccg = cc && cc.prototype && cc.prototype[guardName];

          if (ccg) {
            if (_this5.vuelike && !ccg.isMobxFlow && cc.__flows && ~cc.__flows.indexOf(guardName)) ccg = _this5.vuelike.flow(ccg);
            ret.push(ccg);
          }

          if (_this5._isVuelikeComponent(cc) && Array.isArray(cc.mixins)) {
            cc.mixins.forEach(function (m) {
              var ccg = m[guardName] || m.prototype && m.prototype[guardName];
              if (!ccg) return;
              if (_this5.vuelike && !ccg.isMobxFlow && m.__flows && ~m.__flows.indexOf(guardName)) ccg = _this5.vuelike.flow(ccg);
              ret.push(ccg);
            });
          }
        }

        var ci = componentInstances[key];

        if ((0, _util.isRouteGuardInfoHooks)(ci)) {
          var cig = ci[guardName];
          if (cig) ret.push(cig);
        }

        if (bindInstance) {
          if ((0, _util.isFunction)(bindInstance)) ret = ret.map(function (v) {
            return bindInstance(v, key, ci, mr);
          }).filter(Boolean);else if (ci) ret = ret.map(function (v) {
            return v.bind(ci);
          });
        }

        ret = (0, _util.flatten)(ret);
        ret.forEach(function (v) {
          return v.route = mr;
        });
        return ret;
      }; // route component


      r.components && Object.keys(r.components).forEach(function (key) {
        var c = r.components[key];
        if (!c) return;

        if (c instanceof _routeLazy.RouteLazy) {
          var lazyResovle = /*#__PURE__*/function () {
            var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(interceptors, index) {
              var nc, ret;
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.next = 2;
                      return c.toResolve(r, key);

                    case 2:
                      nc = _context.sent;
                      nc = _this5._callEvent('onResolveComponent', nc, r) || nc;
                      ret = toResovle(nc, key);
                      interceptors.splice.apply(interceptors, [index, 1].concat(_toConsumableArray(ret)));
                      return _context.abrupt("return", interceptors[index]);

                    case 7:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            }));

            return function lazyResovle(_x, _x2) {
              return _ref7.apply(this, arguments);
            };
          }();

          lazyResovle.lazy = true;
          lazyResovle.route = mr;
          ret.push(lazyResovle);
        } else ret.push.apply(ret, _toConsumableArray(toResovle(c, key)));
      });
      return ret;
    }
  }, {
    key: "_getRouteComponentGurads",
    value: function _getRouteComponentGurads(matched, guardName) {
      var _this6 = this;

      var reverse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var bindInstance = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var ret = [];
      if (reverse) matched = matched.reverse();
      matched.forEach(function (r) {
        var guards = _this6._getComponentGurads(r, guardName, bindInstance);

        ret.push.apply(ret, _toConsumableArray(guards));
      });
      return ret;
    }
  }, {
    key: "_getSameMatched",
    value: function _getSameMatched(route, compare) {
      var ret = [];
      if (!compare) return [];
      route && route.matched.some(function (tr, i) {
        var fr = compare.matched[i];
        if (tr.path !== fr.path) return true;
        ret.push(tr);
      });
      return ret.filter(function (r) {
        return !r.redirect;
      });
    }
  }, {
    key: "_getChangeMatched",
    value: function _getChangeMatched(route, compare) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var ret = [];
      if (!compare) return _toConsumableArray(route.matched);
      var start = false;
      route && route.matched.some(function (tr, i) {
        var fr = compare.matched[i];

        if (!start) {
          start = options.containLazy && (0, _routeLazy.hasRouteLazy)(tr) || !fr || fr.path !== tr.path;
          if (!start) return;
        }

        ret.push(tr);
        return typeof options.count === 'number' && ret.length === options.count;
      });
      return ret.filter(function (r) {
        return !r.redirect;
      });
    }
  }, {
    key: "_getBeforeEachGuards",
    value: function _getBeforeEachGuards(to, from) {
      var _this7 = this;

      var current = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      var ret = _toConsumableArray(this.beforeEachGuards);

      if (this.viewRoot && this.viewRoot.props.beforeEach) {
        this.viewRoot.props.beforeEach.global = true;
        ret.push(this.viewRoot.props.beforeEach);
      }

      var view = this;

      if (from) {
        var fm = this._getChangeMatched(from, to).filter(function (r) {
          return Object.keys(r.viewInstances).some(function (key) {
            return r.viewInstances[key];
          });
        });

        ret.push.apply(ret, _toConsumableArray(this._getRouteComponentGurads(fm, 'beforeRouteLeave', true, function (fn, name, ci, r) {
          return function beforeRouteLeaveWraper(to, from, next) {
            return fn.call(ci, to, from, function (cb) {
              if ((0, _util.isFunction)(cb)) {
                var _cb = cb;

                cb = function cb() {
                  var res = _cb.apply(void 0, arguments);

                  view._callEvent('onRouteLeaveNext', r, ci, res);

                  return res;
                };
              }

              for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                args[_key2 - 1] = arguments[_key2];
              }

              return next.apply(void 0, [cb].concat(args));
            }, r);
          };
        })));
      }

      if (to) {
        var tm = this._getChangeMatched(to, from, {
          containLazy: true
        });

        tm.forEach(function (r) {
          var guards = _this7._getComponentGurads(r, 'beforeRouteEnter', function (fn, name) {
            return function beforeRouteEnterWraper(to, from, next) {
              return fn(to, from, function (cb) {
                if ((0, _util.isFunction)(cb)) {
                  var _cb = cb;
                  r.config._pending && (r.config._pending.completeCallbacks[name] = function (ci) {
                    var res = _cb(ci);

                    view._callEvent('onRouteEnterNext', r, ci, res);

                    return res;
                  });
                  cb = undefined;
                }

                for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                  args[_key3 - 1] = arguments[_key3];
                }

                return next.apply(void 0, [cb].concat(args));
              }, r);
            };
          });

          ret.push.apply(ret, _toConsumableArray(guards));
        });
      }

      return (0, _util.flatten)(ret);
    }
  }, {
    key: "_getBeforeResolveGuards",
    value: function _getBeforeResolveGuards(to, from) {
      var ret = _toConsumableArray(this.beforeResolveGuards);

      if (this.viewRoot && this.viewRoot.props.beforeResolve) {
        this.viewRoot.props.beforeResolve.global = true;
        ret.push(this.viewRoot.props.beforeResolve);
      }

      if (to) {
        var tm = this._getChangeMatched(to, from);

        ret.push.apply(ret, _toConsumableArray(this._getRouteComponentGurads(tm.filter(function (r) {
          return !r.redirect;
        }), 'beforeRouteResolve', true)));
      }

      return (0, _util.flatten)(ret);
    }
  }, {
    key: "_getRouteUpdateGuards",
    value: function _getRouteUpdateGuards(to, from) {
      var ret = [];
      var fm = [];
      to && to.matched.some(function (tr, i) {
        var fr = from && from.matched[i];
        if (!fr || fr.path !== tr.path) return true;
        fm.push(fr);
      });
      ret.push.apply(ret, _toConsumableArray(this._getRouteComponentGurads(fm.filter(function (r) {
        return !r.redirect;
      }), 'beforeRouteUpdate', true)));
      return ret;
    }
  }, {
    key: "_getAfterEachGuards",
    value: function _getAfterEachGuards(to, from) {
      var ret = [];

      if (from) {
        var fm = this._getChangeMatched(from, to).filter(function (r) {
          return Object.keys(r.viewInstances).some(function (key) {
            return r.viewInstances[key];
          });
        });

        ret.push.apply(ret, _toConsumableArray(this._getRouteComponentGurads(fm, 'afterRouteLeave', true)));
      }

      if (this.viewRoot && this.viewRoot.props.afterEach) {
        this.viewRoot.props.afterEach.global = true;
        ret.push(this.viewRoot.props.afterEach);
      }

      ret.push.apply(ret, _toConsumableArray(this.afterEachGuards));
      return (0, _util.flatten)(ret);
    }
  }, {
    key: "_transformLocation",
    value: function _transformLocation(location) {
      if (!location || (0, _util.isRoute)(location)) return location;

      if (this.basename && !this.isMemoryMode) {
        var pathname = location.pathname;
        if (location.basename) pathname = location.basename + pathname;
        if (!/\/$/.test(pathname)) pathname += '/';
        var isCurrentBasename = pathname.indexOf(this.basename) === 0;
        location = _objectSpread({}, location);
        location.pathname = isCurrentBasename ? location.pathname.substr(this.basename.length - 1) || '/' : '';
        if (location.path !== undefined) location.path = location.pathname;
        location.fullPath = isCurrentBasename ? location.pathname + location.search : '';
      }

      return location;
    }
  }, {
    key: "_handleRouteInterceptor",
    value: function () {
      var _handleRouteInterceptor2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(location, callback) {
        var isInit,
            pathname,
            url,
            _args2 = arguments;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                isInit = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : false;

                if (this.isRunning) {
                  _context2.next = 3;
                  break;
                }

                return _context2.abrupt("return", callback(true));

              case 3:
                if (!location) {
                  _context2.next = 11;
                  break;
                }

                pathname = location.path || location.pathname;

                if (isInit && this.basename && !this.isMemoryMode && !location.basename && this.history.location.pathname === pathname) {
                  if (this.parent && this.parent.currentRoute) {
                    url = this.parent.currentRoute.url;
                    if (url && this.parent.basename) url = this.parent.basename.substr(0, this.parent.basename.length - 1) + url;

                    if (!pathname.startsWith(url)) {
                      if (location.pathname != null) location.pathname = url;
                      if (location.path != null) location.path = url;
                      if (location.query) location.query = this.parent.currentRoute.query;
                      if (!(0, _util.isReadonly)(location, 'search')) location.search = this.parent.currentRoute.search;
                    }
                  }
                }

                if (!(this.pendingRoute && this.pendingRoute.fullPath === location.fullPath)) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt("return", callback(true));

              case 8:
                if (!(this.basename && location.absolute)) {
                  _context2.next = 10;
                  break;
                }

                return _context2.abrupt("return", callback(true));

              case 10:
                location = this._transformLocation(location);

              case 11:
                if (!(!location || !location.pathname && this.currentRoute && !this.currentRoute.path)) {
                  _context2.next = 13;
                  break;
                }

                return _context2.abrupt("return", callback(true));

              case 13:
                if (!(!isInit && !location.onInit && (!this.viewRoot || !this.viewRoot.state._routerInited))) {
                  _context2.next = 15;
                  break;
                }

                return _context2.abrupt("return", callback(true));

              case 15:
                this._callEvent('onRouteing', true);

                _context2.prev = 16;
                _context2.next = 19;
                return this._internalHandleRouteInterceptor(location, callback, isInit);

              case 19:
                return _context2.abrupt("return", _context2.sent);

              case 20:
                _context2.prev = 20;

                this._callEvent('onRouteing', false);

                return _context2.finish(20);

              case 23:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[16,, 20, 23]]);
      }));

      function _handleRouteInterceptor(_x3, _x4) {
        return _handleRouteInterceptor2.apply(this, arguments);
      }

      return _handleRouteInterceptor;
    }()
  }, {
    key: "_getInterceptor",
    value: function () {
      var _getInterceptor2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(interceptors, index) {
        var interceptor;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                interceptor = interceptors[index];

              case 1:
                if (!(interceptor && interceptor.lazy)) {
                  _context3.next = 7;
                  break;
                }

                _context3.next = 4;
                return interceptor(interceptors, index);

              case 4:
                interceptor = _context3.sent;
                _context3.next = 1;
                break;

              case 7:
                return _context3.abrupt("return", interceptor);

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function _getInterceptor(_x5, _x6) {
        return _getInterceptor2.apply(this, arguments);
      }

      return _getInterceptor;
    }()
  }, {
    key: "_routetInterceptors",
    value: function () {
      var _routetInterceptors2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(interceptors, to, from, next) {
        var _this8 = this;

        var isBlock, beforeInterceptor, _beforeInterceptor;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _beforeInterceptor = function _beforeInterceptor3() {
                  _beforeInterceptor = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(interceptor, index, to, from, next) {
                    var _this9 = this;

                    var nextWrapper;
                    return regeneratorRuntime.wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            if (interceptor) {
                              _context5.next = 2;
                              break;
                            }

                            return _context5.abrupt("return", next());

                          case 2:
                            nextWrapper = this._nexting = (0, _util.once)( /*#__PURE__*/function () {
                              var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(f1) {
                                var nextInterceptor;
                                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                                  while (1) {
                                    switch (_context4.prev = _context4.next) {
                                      case 0:
                                        if (!isBlock.call(_this9, f1, interceptor, function (v) {
                                          return f1 = v;
                                        })) {
                                          _context4.next = 2;
                                          break;
                                        }

                                        return _context4.abrupt("return", next(f1));

                                      case 2:
                                        if (f1 === true) f1 = undefined;
                                        _context4.prev = 3;
                                        _context4.next = 6;
                                        return _this9._getInterceptor(interceptors, ++index);

                                      case 6:
                                        nextInterceptor = _context4.sent;

                                        if (nextInterceptor) {
                                          _context4.next = 9;
                                          break;
                                        }

                                        return _context4.abrupt("return", next(function (res) {
                                          return (0, _util.isFunction)(f1) && f1(res);
                                        }));

                                      case 9:
                                        _context4.next = 11;
                                        return beforeInterceptor.call(_this9, nextInterceptor, index, to, from, function (res) {
                                          var ret = next(res);
                                          if (interceptor.global) (0, _util.isFunction)(f1) && f1(res);
                                          return ret;
                                        });

                                      case 11:
                                        return _context4.abrupt("return", _context4.sent);

                                      case 14:
                                        _context4.prev = 14;
                                        _context4.t0 = _context4["catch"](3);
                                        console.error(_context4.t0);
                                        next(typeof _context4.t0 === 'string' ? new Error(_context4.t0) : _context4.t0);

                                      case 18:
                                      case "end":
                                        return _context4.stop();
                                    }
                                  }
                                }, _callee4, null, [[3, 14]]);
                              }));

                              return function (_x16) {
                                return _ref8.apply(this, arguments);
                              };
                            }());
                            _context5.next = 5;
                            return interceptor(to, from, nextWrapper, interceptor.route);

                          case 5:
                            return _context5.abrupt("return", _context5.sent);

                          case 6:
                          case "end":
                            return _context5.stop();
                        }
                      }
                    }, _callee5, this);
                  }));
                  return _beforeInterceptor.apply(this, arguments);
                };

                beforeInterceptor = function _beforeInterceptor2(_x11, _x12, _x13, _x14, _x15) {
                  return _beforeInterceptor.apply(this, arguments);
                };

                isBlock = function isBlock(v, interceptor, update) {
                  var _isLocation = typeof v === 'string' || (0, _util.isLocation)(v);

                  if (_isLocation && interceptor) {
                    var _to = (0, _util.normalizeLocation)(v, interceptor.route);

                    if (_to) update(_to);
                    v = _to && _this8.createRoute(_to);

                    if (v && v.fullPath === to.fullPath) {
                      v = undefined;
                      _isLocation = false;
                    }
                  }

                  return !_this8._history || v === false || _isLocation || v instanceof Error;
                };

                if (!next) {
                  _context6.next = 16;
                  break;
                }

                _context6.t0 = beforeInterceptor;
                _context6.t1 = this;
                _context6.next = 8;
                return this._getInterceptor(interceptors, 0);

              case 8:
                _context6.t2 = _context6.sent;
                _context6.t3 = to;
                _context6.t4 = from;
                _context6.t5 = next;
                _context6.next = 14;
                return _context6.t0.call.call(_context6.t0, _context6.t1, _context6.t2, 0, _context6.t3, _context6.t4, _context6.t5);

              case 14:
                _context6.next = 17;
                break;

              case 16:
                _util.afterInterceptors.call(this, interceptors, to, from);

              case 17:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _routetInterceptors(_x7, _x8, _x9, _x10) {
        return _routetInterceptors2.apply(this, arguments);
      }

      return _routetInterceptors;
    }()
  }, {
    key: "_internalHandleRouteInterceptor",
    value: function _internalHandleRouteInterceptor(location, callback) {
      var _this10 = this;

      var isInit = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var isContinue = false;
      var interceptorCounter = ++this._interceptorCounter;

      try {
        var to = this.createRoute(location);
        var from = isInit ? null : to.redirectedFrom && to.redirectedFrom.basename === this.basename ? to.redirectedFrom : this.currentRoute;
        var current = this.currentRoute;

        var checkIsContinue = function checkIsContinue() {
          return !to.path || _this10.isRunning && interceptorCounter === _this10._interceptorCounter && Boolean(_this10.viewRoot && _this10.viewRoot._isMounted);
        };

        var afterCallback = function afterCallback(isContinue, to) {
          if (isContinue) to.onInit && to.onInit(isContinue, to);else to.onAbort && to.onAbort(isContinue, to);

          _this10.nextTick(function () {
            if (!checkIsContinue()) return;

            if (!isInit && (!current || current.fullPath !== to.fullPath)) {
              _this10._routetInterceptors(_this10._getRouteUpdateGuards(to, current), to, current);
            }
          });
        };

        if (!to) return;

        if (from && to.matchedPath === from.matchedPath) {
          isContinue = checkIsContinue();

          if (isContinue) {
            callback(function (newIsContinue) {
              afterCallback(newIsContinue, to);
            }, to);
          } else callback(isContinue, to);

          return;
        }

        var fallbackViews = [];

        if ((0, _routeLazy.hasMatchedRouteLazy)(to.matched)) {
          this.viewRoot && fallbackViews.push(this.viewRoot);

          this._getSameMatched(isInit ? null : this.currentRoute, to).reverse().some(function (m) {
            var keys = Object.keys(m.viewInstances).filter(function (key) {
              return m.viewInstances[key] && m.viewInstances[key].props.fallback;
            });
            if (!keys.length) return;
            return fallbackViews = keys.map(function (key) {
              return m.viewInstances[key];
            });
          });
        }

        fallbackViews.forEach(function (fallbackView) {
          return fallbackView._updateResolving(true);
        });

        this._routetInterceptors(this._getBeforeEachGuards(to, from, current), to, from, function (ok) {
          _this10._nexting = null;
          fallbackViews.length && setTimeout(function () {
            return fallbackViews.forEach(function (fallbackView) {
              return fallbackView._isMounted && fallbackView._updateResolving(false);
            });
          }, 0);
          if (typeof ok === 'string') ok = {
            path: ok
          };
          isContinue = checkIsContinue() && Boolean(ok === undefined || ok && !(ok instanceof Error) && !(0, _util.isLocation)(ok));
          var toLast = to.matched[to.matched.length - 1];

          if (isContinue && toLast && toLast.config.exact && toLast.redirect) {
            ok = (0, _util.resolveRedirect)(toLast.redirect, toLast, to);
            if (ok) isContinue = false;
          }

          var onNext = function onNext(newOk) {
            isContinue = newOk;
            if (isContinue) _this10._routetInterceptors(_this10._getBeforeResolveGuards(to, current), to, current); // callback(isContinue, to);

            afterCallback(isContinue, to);

            if (!isContinue) {
              if ((0, _util.isLocation)(ok)) {
                return _this10.redirect(ok, to.onComplete, to.onAbort, to.onInit || (isInit ? callback : null), to);
              }

              if (ok instanceof Error) _this10.errorCallback && _this10.errorCallback(ok);
              return;
            }

            _this10.nextTick(function () {
              if ((0, _util.isFunction)(ok)) ok = ok(to);
              if (to && (0, _util.isFunction)(to.onComplete)) to.onComplete(Boolean(ok), to);

              _this10._routetInterceptors(_this10._getAfterEachGuards(to, current), to, current);
            });
          };

          if (!isContinue) {
            callback(isContinue, to);
            return onNext(isContinue);
          }

          return callback(onNext, to);
        });
      } catch (ex) {
        console.error(ex);
        if (!isContinue) callback(isContinue, null);
      }
    }
  }, {
    key: "_go",
    value: function _go(to, onComplete, onAbort, onInit, replace) {
      var _this11 = this;

      return new Promise(function (resolve, reject) {
        var _to = (0, _util.normalizeLocation)(to, to && to.route || _this11.currentRoute, {
          basename: _this11.basename,
          mode: _this11.mode,
          resolvePathCb: function resolvePathCb(path, to) {
            return path.replace(/\[([A-z.\-_#@$%^&*():|?<>=+]+)\]/g, function (m, name) {
              var ret = _this11.nameToPath(name, to);

              if (ret == null) throw new Error("route name [".concat(name, "]not be found!"));
              return ret;
            });
          }
        });

        function doComplete(res, _to) {
          onComplete && onComplete(res, _to);
          resolve(res);
        }

        function doAbort(res, _to) {
          onAbort && onAbort(res, _to);
          reject(res === false && _to === null ? new Error('to path cannot be empty!') : res);
        }

        if (!_this11.isRunning) return doAbort(new Error('router is not running!'), null);
        if (!_to) return doAbort(false, null);
        if ((0, _util.isFunction)(onComplete)) _to.onComplete = (0, _util.once)(doComplete);
        if ((0, _util.isFunction)(onAbort)) _to.onAbort = (0, _util.once)(doAbort);
        if (onInit) _to.onInit = onInit;
        if (_this11._nexting) return _this11._nexting(_to);
        if (replace) _to.isReplace = true;

        if (_to.fullPath && (0, _util.isAbsoluteUrl)(_to.fullPath)) {
          if (replace) window.location.replace(_to.fullPath);else window.location.href = _to.fullPath;
          return;
        }

        if (!_this11.viewRoot || !onInit && (!_this11.viewRoot.state._routerInited || !_this11.viewRoot._isMounted)) {
          _this11.pendingRoute = _to;
          var _location = _this11.history.location;
          if (_to.fullPath === "".concat(_location.pathname).concat(_location.search)) return;
        }

        var history = _this11.history;

        if ((_this11.basename || _this11.isMemoryMode) && _to.absolute) {
          if (_this11.top && !_this11.top.basename && !_this11.top.isMemoryMode) {
            history = _this11.top.history;
          } else {
            var url = history.createHref(_to);

            if (_this11.isMemoryMode) {
              var mode = typeof _to.absolute === 'string' ? _to.absolute : '';

              if (!mode || mode === 'memory') {
                var guessMode = (0, _historyFix.getPossibleRouterMode)() || 'hash';
                (0, _util.warn)("[react-view-router] warning: parent router mode is ".concat(mode || 'unknown', ", it could be '").concat(guessMode, "' mode that to go!"));
                mode = guessMode;
              }

              if (mode === 'hash') url = (0, _historyFix.getBaseHref)() + (url.startsWith('#') ? '' : '#') + url;
            }

            if (replace) location.replace(url);else location.href = url;
            return;
          }
        }

        if (_to.backIfVisited && _to.basename === _this11.basename) {
          var getPath = function getPath() {
            var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

            var matched = _this11.getMatched(path);

            return matched.length ? "".concat(_this11.basenameNoSlash).concat(matched[matched.length - 1].path).concat(matched.unmatchedPath) : path;
          };

          var stack = _this11.stacks.find(function (s) {
            var stackPath = getPath(s.pathname);
            var toPath = _to.path || '';
            if (_this11.basename) toPath = toPath.substr(_this11.basenameNoSlash.length, toPath.length);
            return stackPath === getPath(toPath);
          });

          if (stack) return _this11.go(stack);
        }

        if (replace) history.replace(_to);else history.push(_to);
      });
    }
  }, {
    key: "_replace",
    value: function _replace(to, onComplete, onAbort, onInit) {
      return this._go(to, onComplete, onAbort, onInit, true);
    }
  }, {
    key: "_push",
    value: function _push(to, onComplete, onAbort, onInit) {
      return this._go(to, onComplete, onAbort, onInit);
    }
  }, {
    key: "resolveRouteName",
    value: function resolveRouteName(fn) {
      var _this12 = this;

      var _off = function _off() {
        var idx = _this12.resolveNameFns.indexOf(fn);

        if (~idx) _this12.resolveNameFns.splice(idx, 1);
      };

      _off();

      this.resolveNameFns.push(fn);
      return _off;
    }
  }, {
    key: "nameToPath",
    value: function nameToPath(name) {
      var _this13 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      name = (0, _util.camelize)(name);
      var path = this.routeNameMap[name];

      if (path == null) {
        this.resolveNameFns.some(function (fn) {
          var newPath = fn(name, options, _this13);
          if (typeof newPath !== 'string') return;
          path = newPath;
          return true;
        });
      } else if (options.absolute) {
        if (this.basename) path = "".concat(this.basename).concat(path);
      }

      if (path == null && options.absolute && this.parent) {
        path = this.parent.nameToPath(name, options);

        if (path !== null && this.parent.basename) {
          path = "".concat(this.parent.basename).concat(path);
        }
      }

      return path;
    }
  }, {
    key: "updateRouteMeta",
    value: function updateRouteMeta(route, newValue) {
      if (!route || !route.meta) return;
      var changed = false;
      var oldValue = {};
      Object.keys(newValue).forEach(function (key) {
        if (route.meta[key] === newValue[key]) return;
        oldValue[key] = route.meta[key];
        changed = true;
      });
      if (!changed) return;
      Object.assign(route.meta, newValue);

      this._callEvent('onRouteMetaChange', newValue, oldValue, route, this);

      return changed;
    }
  }, {
    key: "createMatchedRoute",
    value: function createMatchedRoute(route, match) {
      var _ref9 = match || {},
          url = _ref9.url,
          _ref9$path = _ref9.path,
          path = _ref9$path === void 0 ? route.path : _ref9$path,
          regx = _ref9.regx,
          params = _ref9.params;

      var subpath = route.subpath,
          _route$meta = route.meta,
          meta = _route$meta === void 0 ? {} : _route$meta,
          redirect = route.redirect,
          depth = route.depth;
      return {
        url: url,
        path: path,
        subpath: subpath,
        depth: depth,
        regx: regx,
        meta: meta,
        redirect: redirect,
        params: params,
        componentInstances: {},
        viewInstances: {},
        config: route
      };
    }
  }, {
    key: "getMatched",
    value: function getMatched(to, from, parent) {
      var _this14 = this;

      if (!from) from = this.currentRoute;

      function copyInstance(to, from) {
        if (!from) return;
        if (from.componentInstances) to.componentInstances = from.componentInstances;
        if (from.viewInstances) to.viewInstances = from.viewInstances;
      }

      var matched = (0, _util.matchRoutes)(this.routes, to, parent);
      var isHistoryLocation = !(0, _util.isRoute)(to) && typeof to !== 'string';
      var state = isHistoryLocation && to.state && to.state[this.basename || DEFAULT_STATE_NAME] || {};
      var ret = matched.map(function (_ref10, i) {
        var route = _ref10.route,
            match = _ref10.match;

        var ret = _this14.createMatchedRoute(route, match);

        ret.state = state[ret.url] || {};

        if (from) {
          var fr = from.matched[i];
          var tr = matched[i];
          if (fr && tr && fr.path === tr.match.path) copyInstance(ret, fr);
        }

        return ret;
      });
      (0, _util.innumerable)(ret, 'unmatchedPath', matched.unmatchedPath || '');
      return ret;
    }
  }, {
    key: "getMatchedComponents",
    value: function getMatchedComponents(to, from, parent) {
      var ret = [];
      this.getMatched(to, from, parent).forEach(function (r) {
        Array.prototype.push.apply(ret, Object.values(r.componentInstances));
      });
      return ret.filter(Boolean);
    }
  }, {
    key: "getMatchedViews",
    value: function getMatchedViews(to, from, parent) {
      var ret = [];
      this.getMatched(to, from, parent).map(function (r) {
        Array.prototype.push.apply(Object.values(r.viewInstances));
      });
      return ret.filter(Boolean);
    }
  }, {
    key: "createRoute",
    value: function createRoute(to, from) {
      if ((0, _util.isRoute)(to)) return to;
      if (typeof to === 'string') to = (0, _util.normalizeLocation)(to);
      if (!from && to) from = to.redirectedFrom || this.currentRoute;
      var matched = to ? this.getMatched(to, from) : [];
      var last = matched.length ? matched[matched.length - 1] : {
        url: '',
        path: '',
        params: {},
        meta: {},
        state: {}
      };

      var _ref11 = to || {},
          _ref11$search = _ref11.search,
          search = _ref11$search === void 0 ? '' : _ref11$search,
          query = _ref11.query,
          _ref11$path = _ref11.path,
          path = _ref11$path === void 0 ? '' : _ref11$path,
          _ref11$delta = _ref11.delta,
          delta = _ref11$delta === void 0 ? 0 : _ref11$delta,
          onAbort = _ref11.onAbort,
          onComplete = _ref11.onComplete,
          isRedirect = _ref11.isRedirect,
          isReplace = _ref11.isReplace,
          onInit = _ref11.onInit;

      var ret = {
        action: this.history.action,
        url: last.url,
        basename: this.basename,
        path: path,
        search: search,
        fullPath: "".concat(path).concat(search),
        isRedirect: Boolean(isRedirect),
        isReplace: Boolean(isReplace),
        query: query || (search ? _config.default.parseQuery(search) : {}),
        params: last.params || {},
        matched: matched,
        matchedPath: last.path,
        meta: last.meta || {},

        get state() {
          return last.state;
        },

        delta: delta,
        onAbort: onAbort,
        onComplete: onComplete
      }; // Object.defineProperty(ret, 'fullPath', {
      //   enumerable: true,
      //   configurable: true,
      //   get() {
      //     return `${to.path}${to.search}`;
      //   }
      // });

      (0, _util.innumerable)(ret, 'isViewRoute', true);
      Object.defineProperty(ret, 'origin', {
        configurable: true,
        value: to
      });

      if (isRedirect && from && from.basename === this.basename) {
        ret.redirectedFrom = from;
        if (!ret.onAbort && from.onAbort) ret.onAbort = from.onAbort;
        if (!ret.onComplete && from.onComplete) ret.onComplete = from.onComplete;
        if (!ret.onInit && onInit) ret.onInit = onInit;
      }

      return ret;
    }
  }, {
    key: "updateRoute",
    value: function updateRoute(location) {
      var _this15 = this;

      location = location && this._transformLocation(location);
      if (!location) return;
      if (!this.isRunning && (location.path || this.currentRoute && !this.currentRoute.path)) return;
      this.prevRoute = this.currentRoute;
      var currentRoute = (0, _util.isRoute)(location) ? location : this.createRoute(location, this.prevRoute);
      if (this.currentRoute && this.currentRoute.fullPath === currentRoute.fullPath && this.currentRoute.matched.length === currentRoute.matched.length && this.currentRoute.matched.every(function (v, i) {
        return v.path === currentRoute.matched[i].path;
      })) return;
      this.currentRoute = currentRoute;

      if (this.basename) {
        var basename = this.basenameNoSlash;
        var stacks = [];

        for (var i = this.history.stacks.length - 1; i >= 0; i--) {
          var info = this.history.stacks[i];
          if (!info.pathname.startsWith(basename)) break;
          var pathname = info.pathname.substr(basename.length, info.pathname.length);
          if (!pathname) pathname = '/';
          stacks.unshift(_objectSpread(_objectSpread({}, info), {}, {
            pathname: pathname
          }));
        }

        if (!this.stacks.length && stacks.length) {
          var _this$stacks;

          (_this$stacks = this.stacks).splice.apply(_this$stacks, [0, this.stacks.length].concat(stacks));
        } else {
          var _this$stacks2;

          var idx = this.stacks.findIndex(function (currentStack, i) {
            var newStack = stacks[i];
            if (newStack && currentStack.timestamp === newStack.timestamp) return;
            return true;
          });
          if (idx < 0) idx = 0;

          (_this$stacks2 = this.stacks).splice.apply(_this$stacks2, [idx, this.stacks.length - idx].concat(_toConsumableArray(stacks.slice(idx, stacks.length))));
        }
      } else this.stacks = this.history.stacks;

      var tm = this.prevRoute && this._getChangeMatched(this.prevRoute, this.currentRoute, {
        count: 1
      })[0];

      var called = false;

      var callback = function callback() {
        called = true;

        _this15._callEvent('onRouteChange', _this15.currentRoute, _this15.prevRoute, _this15);
      };

      if (tm) {
        var keys = Object.keys(tm.viewInstances);

        if (keys.length) {
          keys.forEach(function (key, i) {
            var vm = tm && tm.viewInstances[key];
            vm && vm._isMounted && vm._refreshCurrentRoute(undefined, undefined, i === keys.length - 1 ? callback : undefined);
          });
        } else callback();
      } else if (this.viewRoot && this.viewRoot._isMounted) {
        this.viewRoot._refreshCurrentRoute(undefined, undefined, callback);
      }

      if (!called) callback();
    }
  }, {
    key: "push",
    value: function push(to, onComplete, onAbort) {
      return this._push(to, onComplete, onAbort);
    }
  }, {
    key: "replace",
    value: function replace(to, onComplete, onAbort) {
      return this._replace(to, onComplete, onAbort);
    }
  }, {
    key: "redirect",
    value: function redirect(to, onComplete, onAbort, onInit, from) {
      var _to = (0, _util.normalizeLocation)(to);

      if (!_to) return;
      _to.isRedirect = true;
      _to.redirectedFrom = from || this.currentRoute;
      return _to.isReplace || onInit ? this._replace(_to, onComplete, onAbort, onInit) : this._push(_to, onComplete, onAbort, onInit);
    }
  }, {
    key: "go",
    value: function go(n) {
      if (typeof n !== 'number') {
        n = n.index - this.history.index;
        if (!n) return;
      }

      return this.history.go(n);
    }
  }, {
    key: "back",
    value: function back() {
      return this.history.back();
    }
  }, {
    key: "forward",
    value: function forward() {
      return this.history.forward();
    }
  }, {
    key: "replaceState",
    value: function replaceState(newState, matchedRoute) {
      if (!this.isRunning || !this.history.replaceState) return;
      var currentRoute = this.currentRoute || this.initialRoute;
      var mr = matchedRoute || currentRoute && currentRoute.matched[currentRoute.matched.length - 1];
      if (!mr) return;
      var state = this.history.location.state || {};
      var routerStateName = this.basename || DEFAULT_STATE_NAME;
      var routeState = state[routerStateName];
      if (!routeState) routeState = state[routerStateName] = {};
      mr.state = routeState[mr.url] = newState;
      this.history.replaceState(state);
      return newState;
    }
  }, {
    key: "replaceQuery",
    value: function replaceQuery(keyOrObj, value) {
      var currentRoute = this.currentRoute;
      if (!keyOrObj || !currentRoute) return;
      var changed = false;

      var _replaceQuery = function _replaceQuery(key, value) {
        if (currentRoute.query[key] === value) return;
        if (value === undefined) delete currentRoute.query[key];else currentRoute.query[key] = value;
        changed = true;
      };

      if ((0, _util.isPlainObject)(keyOrObj)) Object.keys(keyOrObj).forEach(function (key) {
        return _replaceQuery(key, keyOrObj[key]);
      });else _replaceQuery(keyOrObj, value);
      if (!changed) return;
      currentRoute.search = this.stringifyQuery(currentRoute.query);
      currentRoute.fullPath = "".concat(currentRoute.path).concat(currentRoute.search);
      this.history.replace("".concat(this.basenameNoSlash).concat(currentRoute.fullPath), currentRoute.state);
    }
  }, {
    key: "beforeEach",
    value: function beforeEach(guard) {
      if (!guard || typeof guard !== 'function') return;
      var i = this.beforeEachGuards.indexOf(guard);
      if (~i) this.beforeEachGuards.splice(i, 1);
      guard.global = true;
      this.beforeEachGuards.push(guard);
    }
  }, {
    key: "beforeResolve",
    value: function beforeResolve(guard) {
      if (!guard || typeof guard !== 'function') return;
      var i = this.beforeResolveGuards.indexOf(guard);
      if (~i) this.beforeResolveGuards.splice(i, 1);
      guard.global = true;
      this.beforeResolveGuards.push(guard);
    }
  }, {
    key: "afterEach",
    value: function afterEach(guard) {
      if (!guard || typeof guard !== 'function') return;
      var i = this.afterEachGuards.indexOf(guard);
      if (~i) this.afterEachGuards.splice(i, 1);
      guard.global = true;
      this.afterEachGuards.push(guard);
    }
  }, {
    key: "addRoutes",
    value: function addRoutes(routes, parentRoute) {
      if (!routes) return;
      if (!Array.isArray(routes)) routes = [routes];
      routes = (0, _util.normalizeRoutes)(routes, parentRoute);

      this._walkRoutes(routes);

      var _next = function _next(children) {
        children && routes.forEach(function (r) {
          var i = children.findIndex(function (v) {
            return v.path === r.path;
          });
          if (~i) children.splice(i, 1, r);else children.push(r);
        });
        return children;
      };

      var children = this.routes;

      if (parentRoute) {
        if (!parentRoute.children) parentRoute.children = [];
        children = parentRoute.children;
      }

      if ((0, _util.isFunction)(children)) {
        if (parentRoute) parentRoute.children = function () {
          return _next(children());
        };
      } else {
        _next(children);
      }

      if (!parentRoute && this.viewRoot) this.viewRoot.setState({
        routes: routes
      });
    }
  }, {
    key: "parseQuery",
    value: function parseQuery(query) {
      return _config.default.parseQuery(query);
    }
  }, {
    key: "stringifyQuery",
    value: function stringifyQuery(obj) {
      return _config.default.stringifyQuery(obj);
    }
  }, {
    key: "onError",
    value: function onError(callback) {
      this.errorCallback = callback;
    }
  }, {
    key: "install",
    value: function install(vuelike, _ref12) {
      var _this16 = this;

      var App = _ref12.App;
      this.vuelike = vuelike;

      if (App) {
        var _this$Apps;

        if (!Array.isArray(App)) App = [App];

        (_this$Apps = this.Apps).push.apply(_this$Apps, _toConsumableArray(App));
      }

      var observableRoute = function observableRoute() {
        var currentRoute = _this16.currentRoute || {
          query: {},
          meta: {}
        };
        currentRoute = vuelike.observable(currentRoute, Object.keys(currentRoute).reduce(function (p, key) {
          var d = Object.getOwnPropertyDescriptor(currentRoute, key);
          if (!d || d.get || d.set) return p;
          var v = currentRoute[key];
          if (d.get || d.set) p[key] = vuelike.observable.ref;else {
            p[key] = (0, _util.isPlainObject)(v) || Array.isArray(v) ? vuelike.observable.shallow : vuelike.observable;
          }
          return p;
        }, {}));
        return currentRoute;
      };

      if (vuelike.inherit) {
        vuelike.inherit({
          $router: this,
          $route: observableRoute()
        });
      } else if (App) {
        App.forEach(function (v) {
          if (!v.inherits) v.inherits = {};
          v.inherits.$router = _this16;
          v.inherits.$route = observableRoute();
        });
      }

      _config.default.inheritProps = false;

      if (vuelike.config.inheritMergeStrategies) {
        if (!vuelike.config.inheritMergeStrategies.$route) {
          vuelike.config.inheritMergeStrategies.$route = _config.default.createMergeStrategie(this);
        }
      } else if (vuelike.config.optionMergeStrategies) {
        if (!vuelike.config.optionMergeStrategies.$route) {
          vuelike.config.optionMergeStrategies.$route = _config.default.createMergeStrategie(this);
        }
      }

      var router = this;
      this.plugin({
        name: 'react-view-router-plugin',
        onRouteChange: vuelike.action("[react-view-router][".concat(this.id, "]onRouteChange"), function (newVal) {
          var route = vuelike.observable(newVal, {}, {
            deep: false
          });
          router.apps.forEach(function (app) {
            return app.$route = route;
          });
          vuelike.inherit('$route', route);
          if (vuelike.inherits.$router !== router) vuelike.inherit('$router', router);
        })
      });
    }
  }]);

  return ReactViewRouter;
}();

exports.default = ReactViewRouter;
//# sourceMappingURL=router.js.map